Loading...
Searching...
No Matches
Http_retry_after

## Macros

#define | HTTP_RETRY_AFTER_INIT()
| Initializer for structure http_retry_after_t.
#define | HTTPTAG_RETRY_AFTER(x)
| Tag list item for pointer to a Retry-After header object.
#define | HTTPTAG_RETRY_AFTER_STR(s)
| Tag list item for string with Retry-After header value.

## Typedefs

typedef struct http_retry_after_s | http_retry_after_t
| @HTTP_HEADER http_mime_version MIME-Version header.

## Enumerations

enum | { http_retry_after_hash }

## Functions

http_retry_after_t * | http_retry_after_init (http_retry_after_t x[1])
| Initialize a structure http_retry_after_t.
int | http_is_retry_after (http_header_t const *header)
| Test if header object is instance of http_retry_after_t.
http_retry_after_t * | http_retry_after_dup (su_home_t *home, http_retry_after_t const *hdr))
| Duplicate (deep copy) `http_retry_after_t`.
http_retry_after_t * | http_retry_after_copy (su_home_t *home, http_retry_after_t const *hdr))
| Copy a http_retry_after_t header structure.
http_retry_after_t * | http_retry_after_make (su_home_t *home, char const *s))
| Make a header structure http_retry_after_t.
http_retry_after_t * | http_retry_after_format (su_home_t *home, char const *fmt,...)))
| Make a Retry-After header from formatting result.

## Variables

msg_hclass_t | http_retry_after_class []
| Header class for HTTP Retry-After header.
msg_parse_f | http_retry_after_d
| Decode (parse) a Retry-After header.
msg_print_f | http_retry_after_e
| Encode (print) a Retry-After header.

## Detailed Description

## Macro Definition Documentation

## HTTP_RETRY_AFTER_INIT

#define HTTP_RETRY_AFTER_INIT | ( |  | ) |

Initializer for structure http_retry_after_t.

A static http_retry_after_t structure must be initialized with the HTTP_RETRY_AFTER_INIT() macro. For instance,

http_retry_after_t http_retry_after = HTTP_RETRY_AFTER_INIT;
HTTP_RETRY_AFTER_INIT
#define HTTP_RETRY_AFTER_INIT()
Initializer for structure http_retry_after_t.
Definition http_protos.h:8092
http_retry_after_t
struct http_retry_after_s http_retry_after_t
@HTTP_HEADER http_mime_version MIME-Version header.
Definition http.h:143

## HTTPTAG_RETRY_AFTER

#define HTTPTAG_RETRY_AFTER | ( |  | x | ) |

Tag list item for pointer to a Retry-After header object.

The HTTPTAG_RETRY_AFTER() macro is used to include a tag item with a pointer to a http_retry_after_t object in a tag list.

Parameters

  x | pointer to a http_retry_after_t header structure, or NULL.

## HTTPTAG_RETRY_AFTER_STR

#define HTTPTAG_RETRY_AFTER_STR | ( |  | s | ) |

Tag list item for string with Retry-After header value.

The HTTPTAG_RETRY_AFTER_STR() macro is used to include a tag item with a string containing value of a http_retry_after_t header in a tag list.

Parameters

  s | pointer to a string containing http_retry_after_t value, or NULL.

The HTTPTAG_RETRY_AFTER_STR string can be converted to a http_retry_after_t header structure by giving the string s has second argument to function http_retry_after_make().

## Typedef Documentation

## http_retry_after_t

typedef struct http_retry_after_s http_retry_after_t

@HTTP_HEADER http_mime_version MIME-Version header.

We use MIME MIME-Version header. @HTTP_HEADER http_retry_after Retry-After header.

The Retry-After response-header field can be used with a 503 (Service Unavailable) response to indicate how long the service is expected to be unavailable to the requesting client. This field MAY also be used with any 3xx (Redirection) response to indicate the minimum time the user-agent is asked wait before issuing the redirected request. Its syntax is defined in RFC 2616 section 14.37 as follows:

Retry-After = "Retry-After" ":" ( HTTP-date / delta-seconds )

The structure http_retry_after_t contains representation of Retry-After header.

The http_retry_after_t is defined as follows:

typedef struct {
msg_common_t ra_common[1]; // Common fragment info
msg_error_t *ra_next; // Link to next (dummy)
http_time_t ra_date; // When to retry
http_time_t ra_delta; // Seconds to before retry
} http_retry_after_t;
msg_error_t
struct msg_error_s msg_error_t
http_time_t
unsigned long http_time_t
Time in seconds since 01-Jan-1900.
Definition http.h:169
msg_common_t
struct msg_common_s msg_common_t

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
http_retry_after_hash | Hash of Retry-After header.

## Function Documentation

## http_is_retry_after()

int http_is_retry_after | ( | http_header_t const * | header | ) |

inline

Test if header object is instance of http_retry_after_t.

The function http_is_retry_after() returns true (nonzero) if the header class is an instance of Retry-After header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function http_is_xretry_after() returns true (nonzero) if the header object is an instance of header retry_after and false (zero) otherwise.

## http_retry_after_copy()

http_retry_after_t * http_retry_after_copy | ( | su_home_t * | home,
|  | http_retry_after_t const * | hdr )

inline

Copy a http_retry_after_t header structure.

The function http_retry_after_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  retry_after = http_retry_after_copy(home, http->http_retry_after);
  http_retry_after_copy
  http_retry_after_t * http_retry_after_copy(su_home_t *home, http_retry_after_t const *hdr))
  Copy a http_retry_after_t header structure.
  Definition http_protos.h:8286

Returns
  The function http_retry_after_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## http_retry_after_dup()

http_retry_after_t * http_retry_after_dup | ( | su_home_t * | home,
|  | http_retry_after_t const * | hdr )

inline

Duplicate (deep copy) `http_retry_after_t`.

The function http_retry_after_dup() duplicates a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  retry_after = http_retry_after_dup(home, http->http_retry_after);
  http_retry_after_dup
  http_retry_after_t * http_retry_after_dup(su_home_t *home, http_retry_after_t const *hdr))
  Duplicate (deep copy) http_retry_after_t.
  Definition http_protos.h:8279

Returns
  The function http_retry_after_dup() returns a pointer to the newly duplicated http_retry_after_t header structure, or NULL upon an error.

## http_retry_after_format()

http_retry_after_t * http_retry_after_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Retry-After header from formatting result.

The function http_retry_after_format() makes a new Retry-After header object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function is usually implemented as a macro calling msg_header_format().

Returns
  The function http_retry_after_format() returns a pointer to newly makes header structure, or NULL upon an error.

## http_retry_after_init()

http_retry_after_t * http_retry_after_init | ( | http_retry_after_t | x[1] | ) |

inline

Initialize a structure http_retry_after_t.

An http_retry_after_t structure can be initialized with the http_retry_after_init() function/macro. For instance,

http_retry_after_t http_retry_after;
http_retry_after_init(&http_retry_after);
http_retry_after_init
http_retry_after_t * http_retry_after_init(http_retry_after_t x[1])
Initialize a structure http_retry_after_t.
Definition http_protos.h:8108

## http_retry_after_make()

http_retry_after_t * http_retry_after_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure http_retry_after_t.

The function http_retry_after_make() makes a new http_retry_after_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function is usually implemented as a macro calling http_header_make().

Returns
  The function http_retry_after_make() returns a pointer to newly maked http_retry_after_t header structure, or NULL upon an error.

## Variable Documentation

## http_retry_after_class

msg_hclass_t http_retry_after_class[]

extern

Header class for HTTP Retry-After header.

The header class http_retry_after_class defines how a HTTP Retry-After header is parsed and printed. It also contains methods used by HTTP parser and other functions to manipulate the http_retry_after_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.